diff --git a/xen/arch/x86/domctl.c b/xen/arch/x86/domctl.c
index 2a2fe04..3d7fc34 100644
--- a/xen/arch/x86/domctl.c
+++ b/xen/arch/x86/domctl.c
@@ -1404,23 +1404,23 @@ long arch_do_domctl(
             break;
 
         case XEN_DOMCTL_PSR_CAT_OP_GET_L3_CBM:
-            ret = psr_get_l3_cbm(d, domctl->u.psr_cat_op.target,
-                                 &domctl->u.psr_cat_op.data,
-                                 PSR_CBM_TYPE_L3);
+            ret = psr_get_val(d, domctl->u.psr_cat_op.target,
+                              &domctl->u.psr_cat_op.data,
+                              PSR_CBM_TYPE_L3);
             copyback = 1;
             break;
 
         case XEN_DOMCTL_PSR_CAT_OP_GET_L3_CODE:
-            ret = psr_get_l3_cbm(d, domctl->u.psr_cat_op.target,
-                                 &domctl->u.psr_cat_op.data,
-                                 PSR_CBM_TYPE_L3_CODE);
+            ret = psr_get_val(d, domctl->u.psr_cat_op.target,
+                              &domctl->u.psr_cat_op.data,
+                              PSR_CBM_TYPE_L3_CODE);
             copyback = 1;
             break;
 
         case XEN_DOMCTL_PSR_CAT_OP_GET_L3_DATA:
-            ret = psr_get_l3_cbm(d, domctl->u.psr_cat_op.target,
-                                 &domctl->u.psr_cat_op.data,
-                                 PSR_CBM_TYPE_L3_DATA);
+            ret = psr_get_val(d, domctl->u.psr_cat_op.target,
+                              &domctl->u.psr_cat_op.data,
+                              PSR_CBM_TYPE_L3_DATA);
             copyback = 1;
             break;
 
diff --git a/xen/arch/x86/psr.c b/xen/arch/x86/psr.c
index acd180c..b8bb09b 100644
--- a/xen/arch/x86/psr.c
+++ b/xen/arch/x86/psr.c
@@ -52,6 +52,9 @@ struct feat_ops {
     /* get_feat_info is used to get feature HW info. */
     bool (*get_feat_info)(const struct feat_node *feat, enum cbm_type type,
                          uint32_t dat[], uint32_t array_len);
+    /* get_val is used to get feature COS register value. */
+    int (*get_val)(const struct feat_node *feat, unsigned int cos,
+                   enum cbm_type type, uint64_t *val);
 };
 
 /* CAT/CDP HW info data structure. */
@@ -244,9 +247,42 @@ static bool l3_cat_get_feat_info(const struct feat_node *feat,
     return true;
 }
 
+static int l3_cat_get_val(const struct feat_node *feat, unsigned int cos,
+                          enum cbm_type type, uint64_t *val)
+{
+    if ( cos > feat->info.cos_max )
+        /* Use default value. */
+        cos = 0;
+
+    switch ( type ) {
+    /* CDP */
+    case PSR_CBM_TYPE_L3_DATA:
+    case PSR_CBM_TYPE_L3_CODE:
+        if ( feat->feature != PSR_SOCKET_L3_CDP )
+            return -ENXIO;
+
+        if ( type == PSR_CBM_TYPE_L3_DATA )
+            *val = get_cdp_data(feat, cos);
+        else
+            *val = get_cdp_code(feat, cos);
+        break;
+
+    /* CAT */
+    case PSR_CBM_TYPE_L3:
+        *val =  feat->cos_reg_val[cos];
+        break;
+
+    default:
+        return 0;
+    }
+
+    return 1;
+}
+
 struct feat_ops l3_cat_ops = {
     .init_feature = l3_cat_init_feature,
     .get_feat_info = l3_cat_get_feat_info,
+    .get_val = l3_cat_get_val,
 };
 
 static unsigned int get_socket_cpu(unsigned int socket)
@@ -486,45 +522,26 @@ int psr_get_info(unsigned int socket, enum cbm_type type,
     return -ENOENT;
 }
 
-int psr_get_l3_cbm(struct domain *d, unsigned int socket,
-                   uint64_t *cbm, enum cbm_type type)
+int psr_get_val(struct domain *d, unsigned int socket,
+                uint64_t *val, enum cbm_type type)
 {
-    struct psr_cat_socket_info *info = get_cat_socket_info(socket);
-    bool_t cdp_enabled = cdp_is_enabled(socket);
+    const struct psr_cat_socket_info *info = get_cat_socket_info(socket);
     unsigned int cos = d->arch.psr_cos_ids[socket];
-    struct feat_node *feat_tmp;
+    const struct feat_node *feat_tmp;
+    int ret;
 
     if ( IS_ERR(info) )
         return PTR_ERR(info);
 
-    feat_tmp = get_feat_l3(info);
-    if ( !feat_tmp )
-        return -ENOENT;
-
-    switch ( type )
+    list_for_each_entry(feat_tmp, &info->feat_list, list)
     {
-    case PSR_CBM_TYPE_L3:
-        if ( cdp_enabled )
-            return -EXDEV;
-        *cbm = feat_tmp->cos_reg_val[cos];
-        break;
+        ret = feat_tmp->ops.get_val(feat_tmp, cos, type, val);
+        if ( ret < 0 )
+            return ret;
 
-    case PSR_CBM_TYPE_L3_CODE:
-        if ( !cdp_enabled )
-            *cbm = feat_tmp->cos_reg_val[cos];
-        else
-            *cbm = get_cdp_code(feat_tmp, cos);
-        break;
-
-    case PSR_CBM_TYPE_L3_DATA:
-        if ( !cdp_enabled )
-            *cbm = feat_tmp->cos_reg_val[cos];
-        else
-            *cbm = get_cdp_data(feat_tmp, cos);
-        break;
-
-    default:
-        ASSERT_UNREACHABLE();
+        if ( ret > 0 )
+            /* Found */
+            break;
     }
 
     return 0;
diff --git a/xen/include/asm-x86/psr.h b/xen/include/asm-x86/psr.h
index eccfa75..f2872a2 100644
--- a/xen/include/asm-x86/psr.h
+++ b/xen/include/asm-x86/psr.h
@@ -65,8 +65,8 @@ void psr_ctxt_switch_to(struct domain *d);
 
 int psr_get_info(unsigned int socket, enum cbm_type type,
                  uint32_t dat[], uint32_t array_len);
-int psr_get_l3_cbm(struct domain *d, unsigned int socket,
-                   uint64_t *cbm, enum cbm_type type);
+int psr_get_val(struct domain *d, unsigned int socket,
+                uint64_t *val, enum cbm_type type);
 int psr_set_l3_cbm(struct domain *d, unsigned int socket,
                    uint64_t cbm, enum cbm_type type);
 